package com.rjconsultores.ventaboletos.web.gui.controladores.esquemaoperacional;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Paging;

import com.rjconsultores.ventaboletos.entidad.AliasServico;
import com.rjconsultores.ventaboletos.entidad.ClaseServicio;
import com.rjconsultores.ventaboletos.entidad.OrgaoConcedente;
import com.rjconsultores.ventaboletos.service.ClaseServicioService;
import com.rjconsultores.ventaboletos.service.OrgaoConcedenteService;
import com.rjconsultores.ventaboletos.web.utilerias.MyComboboxEstandar;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderAliasServico;

@Controller("busquedaAliasClasseController")
@Scope("prototype")
public class BusquedaAliasClasseController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;
	@Autowired
	private transient PagedListWrapper<AliasServico> plwAliasServico;
	
	@Autowired
    private ClaseServicioService claseServicioService;
	
	@Autowired
	private OrgaoConcedenteService orgaoConcedenteService;
	
	private List<ClaseServicio> lsClasse;
	private List<OrgaoConcedente> lsOrgaoConcedente;
	
	private MyListbox aliasServicoList;
	private Paging pagingAliasServico;
	
	private MyComboboxEstandar cmbClasse;
	private MyComboboxEstandar cmbAlias;
	private MyComboboxEstandar cmbOrgaoConcedente;

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		
		super.doAfterCompose(comp);
		
		lsClasse = claseServicioService.obtenerTodos();
		lsOrgaoConcedente = orgaoConcedenteService.obtenerTodos();
/*
		aliasServicoList.setItemRenderer(new RenderAliasServico());
		aliasServicoList.addEventListener("onDoubleClick", new EventListener() {

			@Override
			public void onEvent(Event event) throws Exception {
				AliasServico as = (AliasServico) aliasServicoList.getSelected();
				verAliasServico(as);
			}
		});
*/
		refreshLista();
	}

	@SuppressWarnings({ "rawtypes", "unchecked" })
	private void verAliasServico(AliasServico as) {
		if (as == null) {
			return;
		}

		Map args = new HashMap();
		args.put("aliasServico", as);
		args.put("aliasServicoList", aliasServicoList);

		openWindow("/gui/esquema_operacional/editarAliasServico.zul",
				Labels.getLabel("editarAliasServicoController.window.title"), args, MODAL);
	}

	private void refreshLista() {
		/*
		HibernateSearchObject<AliasServico> aliasServicoBusqueda =
				new HibernateSearchObject<AliasServico>(AliasServico.class, pagingAliasServico.getPageSize());

		aliasServicoBusqueda.addFilterEqual("activo", true);

	

		aliasServicoBusqueda.addSortAsc("aliasServicoId");

		plwAliasServico.init(aliasServicoBusqueda, aliasServicoList, pagingAliasServico);

		if (aliasServicoList.getData().length == 0) {
			try {
				Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
						Labels.getLabel("busquedaAutobusController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);
			} catch (InterruptedException ex) {
			}
		}
		*/
	}

	public void onClick$btnPesquisa(Event ev) {
		refreshLista();
	}

	public void onClick$btnRefresh(Event ev) {
		refreshLista();
	}

	public void onClick$btnNovo(Event ev) {
		verAliasServico(new AliasServico());
	}

	public List<ClaseServicio> getLsClasse() {
		return lsClasse;
	}

	public void setLsClasse(List<ClaseServicio> lsClasse) {
		this.lsClasse = lsClasse;
	}

	public List<OrgaoConcedente> getLsOrgaoConcedente() {
		return lsOrgaoConcedente;
	}

	public void setLsOrgaoConcedente(List<OrgaoConcedente> lsOrgaoConcedente) {
		this.lsOrgaoConcedente = lsOrgaoConcedente;
	}

	public MyComboboxEstandar getCmbClasse() {
		return cmbClasse;
	}

	public void setCmbClasse(MyComboboxEstandar cmbClasse) {
		this.cmbClasse = cmbClasse;
	}

	public MyComboboxEstandar getCmbAlias() {
		return cmbAlias;
	}

	public void setCmbAlias(MyComboboxEstandar cmbAlias) {
		this.cmbAlias = cmbAlias;
	}

	public MyComboboxEstandar getCmbOrgaoConcedente() {
		return cmbOrgaoConcedente;
	}

	public void setCmbOrgaoConcedente(MyComboboxEstandar cmbOrgaoConcedente) {
		this.cmbOrgaoConcedente = cmbOrgaoConcedente;
	}
}
